#ifndef _HALTON_H
#define _HALTON_H

    /* 
    Copyright Emanouil Atanassov, 2003
    This file is part of the Fast Generator for the Halton Sequences.

    The Fast Generator for the Halton Sequences
    is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

     The Fast Generator for the Halton Sequences 
    is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the Fast Generator for the Halton Sequences; 
    if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */


#ifdef __cplusplus
extern "C" {
#endif
#define HALTON_MAXDIM 1000
#define HALTON_MAXDIGS 64
#ifdef HALTON_SINGLE
		typedef float halton_real;
#else
		typedef double halton_real;
#endif
extern void haltonpreprocess(double,int,int,int**);       	
extern void haltonnextpoint(halton_real*);
double halton_test_get_point(double ,int ,int,int*);
extern halton_real *haltonalignmem(int);
extern void haltonnexttraj();
extern int  haltondim;
extern halton_real  haltonpoints[HALTON_MAXDIM];
extern void    haltonprepare(double from,int modified, int scrambled, int dim);
extern double (*haltonranfunc)();
extern halton_real  *haltonptr;
extern halton_real  *haltonrbound;
extern short int haltonprimes[HALTON_MAXDIM];
extern int haltonkmod[HALTON_MAXDIM];
extern int haltonkmod1[HALTON_MAXDIM];


#define haltonnextcoord() (*haltonptr++)
#define haltonnextcoordr() ((haltonptr<haltonrbound)?*haltonptr++:haltonranfunc())




#ifdef __cplusplus
}
#endif
#endif
